package org.unidal.dal.jdbc.datasource.model.transform;

import static org.unidal.dal.jdbc.datasource.model.Constants.ATTR_ID;
import static org.unidal.dal.jdbc.datasource.model.Constants.ATTR_TYPE;

import org.xml.sax.Attributes;

import org.unidal.dal.jdbc.datasource.model.entity.DataSourceDef;
import org.unidal.dal.jdbc.datasource.model.entity.DataSourcesDef;
import org.unidal.dal.jdbc.datasource.model.entity.PropertiesDef;

public class DefaultSaxMaker implements IMaker<Attributes> {

   @Override
   public DataSourceDef buildDataSource(Attributes attributes) {
      String id = attributes.getValue(ATTR_ID);
      String type = attributes.getValue(ATTR_TYPE);
      DataSourceDef dataSource = new DataSourceDef(id);

      if (type != null) {
         dataSource.setType(type);
      }

      return dataSource;
   }

   @Override
   public DataSourcesDef buildDataSources(Attributes attributes) {
      DataSourcesDef dataSources = new DataSourcesDef();

      return dataSources;
   }

   @Override
   public PropertiesDef buildProperties(Attributes attributes) {
      PropertiesDef properties = new PropertiesDef();

      return properties;
   }

   @SuppressWarnings("unchecked")
   protected <T> T convert(Class<T> type, String value, T defaultValue) {
      if (value == null || value.length() == 0) {
         return defaultValue;
      }

      if (type == Boolean.class || type == Boolean.TYPE) {
         return (T) Boolean.valueOf(value);
      } else if (type == Integer.class || type == Integer.TYPE) {
         return (T) Integer.valueOf(value);
      } else if (type == Long.class || type == Long.TYPE) {
         return (T) Long.valueOf(value);
      } else if (type == Short.class || type == Short.TYPE) {
         return (T) Short.valueOf(value);
      } else if (type == Float.class || type == Float.TYPE) {
         return (T) Float.valueOf(value);
      } else if (type == Double.class || type == Double.TYPE) {
         return (T) Double.valueOf(value);
      } else if (type == Byte.class || type == Byte.TYPE) {
         return (T) Byte.valueOf(value);
      } else if (type == Character.class || type == Character.TYPE) {
         return (T) (Character) value.charAt(0);
      } else {
         return (T) value;
      }
   }
}
