package org.unidal.dal.jdbc.test.data.entity;

import java.util.ArrayList;
import java.util.List;

import org.unidal.dal.jdbc.test.data.BaseEntity;
import org.unidal.dal.jdbc.test.data.IVisitor;

public class DatabaseModel extends BaseEntity<DatabaseModel> {
   private List<TableModel> m_tables = new ArrayList<TableModel>();

   public DatabaseModel() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitDatabase(this);
   }

   public DatabaseModel addTable(TableModel table) {
      m_tables.add(table);
      return this;
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof DatabaseModel) {
         DatabaseModel _o = (DatabaseModel) obj;

         if (!equals(getTables(), _o.getTables())) {
            return false;
         }


         return true;
      }

      return false;
   }

   public TableModel findTable(String name) {
      for (TableModel table : m_tables) {
         if (!equals(table.getName(), name)) {
            continue;
         }

         return table;
      }

      return null;
   }

   public List<TableModel> getTables() {
      return m_tables;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      for (TableModel e : m_tables) {
         hash = hash * 31 + (e == null ? 0 :e.hashCode());
      }


      return hash;
   }

   @Override
   public void mergeAttributes(DatabaseModel other) {
   }

   public TableModel removeTable(String name) {
      int len = m_tables.size();

      for (int i = 0; i < len; i++) {
         TableModel table = m_tables.get(i);

         if (!equals(table.getName(), name)) {
            continue;
         }

         return m_tables.remove(i);
      }

      return null;
   }

}
