package org.unidal.dal.jdbc.test.meta.entity;

import java.util.ArrayList;
import java.util.List;

import org.unidal.dal.jdbc.test.meta.BaseEntity;
import org.unidal.dal.jdbc.test.meta.IVisitor;

public class EntitiesModel extends BaseEntity<EntitiesModel> {
   private List<EntityModel> m_entities = new ArrayList<EntityModel>();

   public EntitiesModel() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitEntities(this);
   }

   public EntitiesModel addEntity(EntityModel entity) {
      m_entities.add(entity);
      return this;
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof EntitiesModel) {
         EntitiesModel _o = (EntitiesModel) obj;

         if (!equals(m_entities, _o.getEntities())) {
            return false;
         }


         return true;
      }

      return false;
   }

   public List<EntityModel> getEntities() {
      return m_entities;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      hash = hash * 31 + (m_entities == null ? 0 : m_entities.hashCode());

      return hash;
   }

   @Override
   public void mergeAttributes(EntitiesModel other) {
   }

}
