package org.unidal.dal.jdbc.test.meta.entity;

import org.unidal.dal.jdbc.test.meta.BaseEntity;
import org.unidal.dal.jdbc.test.meta.IVisitor;

public class VarModel extends BaseEntity<VarModel> {
   private String m_name;

   private String m_valueType;

   private String m_keyMember;

   public VarModel() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitVar(this);
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof VarModel) {
         VarModel _o = (VarModel) obj;

         if (!equals(getName(), _o.getName())) {
            return false;
         }

         if (!equals(getValueType(), _o.getValueType())) {
            return false;
         }

         if (!equals(getKeyMember(), _o.getKeyMember())) {
            return false;
         }


         return true;
      }

      return false;
   }

   public String getKeyMember() {
      return m_keyMember;
   }

   public String getName() {
      return m_name;
   }

   public String getValueType() {
      return m_valueType;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      hash = hash * 31 + (m_name == null ? 0 : m_name.hashCode());
      hash = hash * 31 + (m_valueType == null ? 0 : m_valueType.hashCode());
      hash = hash * 31 + (m_keyMember == null ? 0 : m_keyMember.hashCode());

      return hash;
   }

   @Override
   public void mergeAttributes(VarModel other) {
      if (other.getName() != null) {
         m_name = other.getName();
      }

      if (other.getValueType() != null) {
         m_valueType = other.getValueType();
      }

      if (other.getKeyMember() != null) {
         m_keyMember = other.getKeyMember();
      }
   }

   public VarModel setKeyMember(String keyMember) {
      m_keyMember = keyMember;
      return this;
   }

   public VarModel setName(String name) {
      m_name = name;
      return this;
   }

   public VarModel setValueType(String valueType) {
      m_valueType = valueType;
      return this;
   }

}
