package org.unidal.dal.jdbc.test.meta.transform;

import org.unidal.dal.jdbc.test.meta.entity.EntitiesModel;
import org.unidal.dal.jdbc.test.meta.entity.EntityModel;
import org.unidal.dal.jdbc.test.meta.entity.IndexModel;
import org.unidal.dal.jdbc.test.meta.entity.MemberModel;
import org.unidal.dal.jdbc.test.meta.entity.ParamModel;
import org.unidal.dal.jdbc.test.meta.entity.PrimaryKeyModel;
import org.unidal.dal.jdbc.test.meta.entity.QueryModel;
import org.unidal.dal.jdbc.test.meta.entity.ReadsetModel;
import org.unidal.dal.jdbc.test.meta.entity.ReadsetsModel;
import org.unidal.dal.jdbc.test.meta.entity.UpdatesetModel;
import org.unidal.dal.jdbc.test.meta.entity.UpdatesetsModel;
import org.unidal.dal.jdbc.test.meta.entity.VarModel;

public interface IParser<T> {
   public EntitiesModel parse(IMaker<T> maker, ILinker linker, T node);

   public void parseForEntityModel(IMaker<T> maker, ILinker linker, EntityModel parent, T node);

   public void parseForIndexModel(IMaker<T> maker, ILinker linker, IndexModel parent, T node);

   public void parseForMemberModel(IMaker<T> maker, ILinker linker, MemberModel parent, T node);

   public void parseForParamModel(IMaker<T> maker, ILinker linker, ParamModel parent, T node);

   public void parseForPrimaryKeyModel(IMaker<T> maker, ILinker linker, PrimaryKeyModel parent, T node);

   public void parseForQueryModel(IMaker<T> maker, ILinker linker, QueryModel parent, T node);

   public void parseForReadsetModel(IMaker<T> maker, ILinker linker, ReadsetModel parent, T node);

   public void parseForReadsetsModel(IMaker<T> maker, ILinker linker, ReadsetsModel parent, T node);

   public void parseForUpdatesetModel(IMaker<T> maker, ILinker linker, UpdatesetModel parent, T node);

   public void parseForUpdatesetsModel(IMaker<T> maker, ILinker linker, UpdatesetsModel parent, T node);

   public void parseForVarModel(IMaker<T> maker, ILinker linker, VarModel parent, T node);
}
