package org.unidal.eunit.benchmark.model.entity;

import java.util.ArrayList;
import java.util.List;

import org.unidal.eunit.benchmark.model.BaseEntity;
import org.unidal.eunit.benchmark.model.IVisitor;

public class BenchmarkEntity extends BaseEntity<BenchmarkEntity> {
   private List<SuiteEntity> m_suites = new ArrayList<SuiteEntity>();

   public BenchmarkEntity() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitBenchmark(this);
   }

   public BenchmarkEntity addSuite(SuiteEntity suite) {
      m_suites.add(suite);
      return this;
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof BenchmarkEntity) {
         BenchmarkEntity _o = (BenchmarkEntity) obj;

         if (!equals(getSuites(), _o.getSuites())) {
            return false;
         }


         return true;
      }

      return false;
   }

   public SuiteEntity findSuite(Class<?> type) {
      for (SuiteEntity suite : m_suites) {
         if (!equals(suite.getType(), type)) {
            continue;
         }

         return suite;
      }

      return null;
   }

   public List<SuiteEntity> getSuites() {
      return m_suites;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      for (SuiteEntity e : m_suites) {
         hash = hash * 31 + (e == null ? 0 :e.hashCode());
      }


      return hash;
   }

   @Override
   public void mergeAttributes(BenchmarkEntity other) {
   }

   public SuiteEntity removeSuite(Class<?> type) {
      int len = m_suites.size();

      for (int i = 0; i < len; i++) {
         SuiteEntity suite = m_suites.get(i);

         if (!equals(suite.getType(), type)) {
            continue;
         }

         return m_suites.remove(i);
      }

      return null;
   }

}
