package org.unidal.eunit.benchmark.model.entity;

import org.unidal.eunit.benchmark.model.BaseEntity;
import org.unidal.eunit.benchmark.model.IVisitor;

public class CpuEntity extends BaseEntity<CpuEntity> {
   private int m_loops;

   private int m_warmups;

   private long m_cpuTime;

   private long m_cpuFirstTime;

   private long m_cpuTotalTime;

   private long m_elapsedTime;

   private long m_elapsedFirstTime;

   private long m_elapsedTotalTime;

   public CpuEntity() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitCpu(this);
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof CpuEntity) {
         CpuEntity _o = (CpuEntity) obj;

         if (getLoops() != _o.getLoops()) {
            return false;
         }

         if (getWarmups() != _o.getWarmups()) {
            return false;
         }

         if (getCpuTime() != _o.getCpuTime()) {
            return false;
         }

         if (getCpuFirstTime() != _o.getCpuFirstTime()) {
            return false;
         }

         if (getCpuTotalTime() != _o.getCpuTotalTime()) {
            return false;
         }

         if (getElapsedTime() != _o.getElapsedTime()) {
            return false;
         }

         if (getElapsedFirstTime() != _o.getElapsedFirstTime()) {
            return false;
         }

         if (getElapsedTotalTime() != _o.getElapsedTotalTime()) {
            return false;
         }


         return true;
      }

      return false;
   }

   public long getCpuFirstTime() {
      return m_cpuFirstTime;
   }

   public long getCpuTime() {
      return m_cpuTime;
   }

   public long getCpuTotalTime() {
      return m_cpuTotalTime;
   }

   public long getElapsedFirstTime() {
      return m_elapsedFirstTime;
   }

   public long getElapsedTime() {
      return m_elapsedTime;
   }

   public long getElapsedTotalTime() {
      return m_elapsedTotalTime;
   }

   public int getLoops() {
      return m_loops;
   }

   public int getWarmups() {
      return m_warmups;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      hash = hash * 31 + m_loops;
      hash = hash * 31 + m_warmups;
      hash = hash * 31 + (int) (m_cpuTime ^ (m_cpuTime >>> 32));
      hash = hash * 31 + (int) (m_cpuFirstTime ^ (m_cpuFirstTime >>> 32));
      hash = hash * 31 + (int) (m_cpuTotalTime ^ (m_cpuTotalTime >>> 32));
      hash = hash * 31 + (int) (m_elapsedTime ^ (m_elapsedTime >>> 32));
      hash = hash * 31 + (int) (m_elapsedFirstTime ^ (m_elapsedFirstTime >>> 32));
      hash = hash * 31 + (int) (m_elapsedTotalTime ^ (m_elapsedTotalTime >>> 32));

      return hash;
   }

   @Override
   public void mergeAttributes(CpuEntity other) {
      m_loops = other.getLoops();

      m_warmups = other.getWarmups();

      m_cpuTime = other.getCpuTime();

      m_cpuFirstTime = other.getCpuFirstTime();

      m_cpuTotalTime = other.getCpuTotalTime();

      m_elapsedTime = other.getElapsedTime();

      m_elapsedFirstTime = other.getElapsedFirstTime();

      m_elapsedTotalTime = other.getElapsedTotalTime();
   }

   public CpuEntity setCpuFirstTime(long cpuFirstTime) {
      m_cpuFirstTime = cpuFirstTime;
      return this;
   }

   public CpuEntity setCpuTime(long cpuTime) {
      m_cpuTime = cpuTime;
      return this;
   }

   public CpuEntity setCpuTotalTime(long cpuTotalTime) {
      m_cpuTotalTime = cpuTotalTime;
      return this;
   }

   public CpuEntity setElapsedFirstTime(long elapsedFirstTime) {
      m_elapsedFirstTime = elapsedFirstTime;
      return this;
   }

   public CpuEntity setElapsedTime(long elapsedTime) {
      m_elapsedTime = elapsedTime;
      return this;
   }

   public CpuEntity setElapsedTotalTime(long elapsedTotalTime) {
      m_elapsedTotalTime = elapsedTotalTime;
      return this;
   }

   public CpuEntity setLoops(int loops) {
      m_loops = loops;
      return this;
   }

   public CpuEntity setWarmups(int warmups) {
      m_warmups = warmups;
      return this;
   }

}
