package org.unidal.eunit.model.transform;

import org.unidal.eunit.model.IVisitor;
import org.unidal.eunit.model.entity.EunitClass;
import org.unidal.eunit.model.entity.EunitException;
import org.unidal.eunit.model.entity.EunitField;
import org.unidal.eunit.model.entity.EunitMethod;
import org.unidal.eunit.model.entity.EunitParameter;

public abstract class BaseVisitor implements IVisitor {
   @Override
   public void visitEunitClass(EunitClass eunitClass) {
      for (EunitField field : eunitClass.getFields()) {
         visitEunitField(field);
      }

      for (EunitMethod method : eunitClass.getMethods()) {
         visitEunitMethod(method);
      }
   }

   @Override
   public void visitEunitException(EunitException eunitException) {
   }

   @Override
   public void visitEunitField(EunitField eunitField) {
   }

   @Override
   public void visitEunitMethod(EunitMethod eunitMethod) {
      for (EunitParameter parameter : eunitMethod.getParameters()) {
         visitEunitParameter(parameter);
      }

      for (EunitException expectedException : eunitMethod.getExpectedExceptions()) {
         visitEunitException(expectedException);
      }
   }

   @Override
   public void visitEunitParameter(EunitParameter eunitParameter) {
   }
}
