package org.unidal.web.mvc.model;

import org.unidal.web.mvc.model.entity.DomainModel;
import org.unidal.web.mvc.model.entity.ErrorModel;
import org.unidal.web.mvc.model.entity.InboundActionModel;
import org.unidal.web.mvc.model.entity.ModuleModel;
import org.unidal.web.mvc.model.entity.OutboundActionModel;
import org.unidal.web.mvc.model.entity.PayloadFieldModel;
import org.unidal.web.mvc.model.entity.PayloadModel;
import org.unidal.web.mvc.model.entity.PayloadObjectModel;
import org.unidal.web.mvc.model.entity.PayloadPathModel;
import org.unidal.web.mvc.model.entity.TransitionModel;

public interface IVisitor {

   public void visitDomain(DomainModel domain);

   public void visitError(ErrorModel error);

   public void visitField(PayloadFieldModel field);

   public void visitInbound(InboundActionModel inbound);

   public void visitModule(ModuleModel module);

   public void visitObject(PayloadObjectModel object);

   public void visitOutbound(OutboundActionModel outbound);

   public void visitPath(PayloadPathModel path);

   public void visitPayload(PayloadModel payload);

   public void visitTransition(TransitionModel transition);
}
