package org.unidal.web.mvc.model.entity;

import java.util.LinkedHashMap;
import java.util.Map;

import org.unidal.web.mvc.model.BaseEntity;
import org.unidal.web.mvc.model.IVisitor;

public class DomainModel extends BaseEntity<DomainModel> {
   private Map<String, ModuleModel> m_modules = new LinkedHashMap<String, ModuleModel>();

   public DomainModel() {
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitDomain(this);
   }

   public DomainModel addModule(ModuleModel module) {
      m_modules.put(module.getModuleName(), module);
      return this;
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof DomainModel) {
         DomainModel _o = (DomainModel) obj;

         if (!equals(getModules(), _o.getModules())) {
            return false;
         }


         return true;
      }

      return false;
   }

   public ModuleModel findModule(String moduleName) {
      return m_modules.get(moduleName);
   }

   public Map<String, ModuleModel> getModules() {
      return m_modules;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      hash = hash * 31 + (m_modules == null ? 0 : m_modules.hashCode());

      return hash;
   }

   @Override
   public void mergeAttributes(DomainModel other) {
   }

   public ModuleModel removeModule(String moduleName) {
      return m_modules.remove(moduleName);
   }

}
