package org.unidal.web.mvc.model.entity;

import static org.unidal.web.mvc.model.Constants.ATTR_ACTIONNAME;
import static org.unidal.web.mvc.model.Constants.ENTITY_OUTBOUND;

import org.unidal.web.mvc.model.BaseEntity;
import org.unidal.web.mvc.model.IVisitor;

public class OutboundActionModel extends BaseEntity<OutboundActionModel> {
   private String m_actionName;

   private transient Object m_moduleInstance;

   private transient java.lang.reflect.Method m_method;

   public OutboundActionModel() {
   }

   public OutboundActionModel(String actionName) {
      m_actionName = actionName;
   }

   @Override
   public void accept(IVisitor visitor) {
      visitor.visitOutbound(this);
   }

   @Override
   public boolean equals(Object obj) {
      if (obj instanceof OutboundActionModel) {
         OutboundActionModel _o = (OutboundActionModel) obj;

         if (!equals(getActionName(), _o.getActionName())) {
            return false;
         }

         return true;
      }

      return false;
   }

   public String getActionName() {
      return m_actionName;
   }

   public java.lang.reflect.Method getMethod() {
      return m_method;
   }

   public Object getModuleInstance() {
      return m_moduleInstance;
   }

   @Override
   public int hashCode() {
      int hash = 0;

      hash = hash * 31 + (m_actionName == null ? 0 : m_actionName.hashCode());

      return hash;
   }

   @Override
   public void mergeAttributes(OutboundActionModel other) {
      assertAttributeEquals(other, ENTITY_OUTBOUND, ATTR_ACTIONNAME, m_actionName, other.getActionName());

   }

   public OutboundActionModel setActionName(String actionName) {
      m_actionName = actionName;
      return this;
   }

   public OutboundActionModel setMethod(java.lang.reflect.Method method) {
      m_method = method;
      return this;
   }

   public OutboundActionModel setModuleInstance(Object moduleInstance) {
      m_moduleInstance = moduleInstance;
      return this;
   }

}
